// array of edges representation
typedef struct GraphRep {
	int   nV;    // #vertices
	int   nE;    // #edges
	int   n;     // size of edge array
	Edge *edges; // array of edges
} GraphRep;


// assumption: no order on vertices in edges

// check for an edge between two vertices
int connected(Graph g, Vertex x, Vertex y)
{
	Edge e;
	// check whether it's in edges as (x,y)
	e = mkEdge(g,x,y);
	for (i = 0; i < g->nE; i++)
		if (eq(g->edges[i],e)) return TRUE;
	// check whether it's in edges as (y,x)
	e = mkEdge(g,y,x);
	for (i = 0; i < g->nE; i++)
		if (eq(g->edges[i],e)) return TRUE;
	// not in graph either as (x,y) or (y,x)
	return FALSE;
}


// assumption: small vertex first in all edges

// check for an edge between two vertices
int connected(Graph g, Vertex x, Vertex y)
{
	// ensure that (x,y) has x < y
	Edge e = (x < y) ? mkEdge(g,x,y) : mkEdge(g,y,x);
	// check whether it's in edges as (x,y)
	for (i = 0; i < g->nE; i++)
		if (eq(g->edges[i],e)) return TRUE;
	return FALSE;
}
