// array of edges representation
typedef struct GraphRep {
	int   nV;    // #vertices
	int   nE;    // #edges
	int   n;     // size of edge array
	Edge *edges; // array of edges
} GraphRep;

// Usage: isIt = connected(g, x, y)
// Pre:  valid(g) and valid(x) && valid(y)
// Post: res = True,  if edge (x,y) exists in g->edges
//       res = False, otherwise


// assumption: no order on vertices in edges

bool connected(Graph g, Vertex x, Vertex y)
{
	assert(validG(g) && validV(g,x) && validV(g,y));
	Edge e = mkEdge(x,y);
	int i;
	for (i = 0; i < g->nE; i++)
		if (cmpE(e,g->edges[i]) == 0) return true;
	return false;
}

	// if sorted array of canonical edges
	int i = bSearch(g->edges,0,g->nE-1,e);
	return (cmpE(g->edges[i],e) == 0);


// assumption: small vertex first in all edges

bool connected(Graph g, Vertex x, Vertex y)
{
        assert(validG(g) && validV(g,x) && validV(g,y));
        ...
}
